-- MySQL Script generated by MySQL Workbench
-- Mon Nov 29 14:07:09 2021
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION';

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------
DROP SCHEMA IF EXISTS `mydb` ;

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `mydb` DEFAULT CHARACTER SET utf8 ;
USE `mydb` ;

-- -----------------------------------------------------
-- Table `mydb`.`users`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`users` ;

CREATE TABLE IF NOT EXISTS `mydb`.`users` (
  `id` INT NOT NULL,
  `fullName` VARCHAR(200) NULL,
  `email` VARCHAR(45) NULL,
  `username` VARCHAR(45) NULL,
  `phone` VARCHAR(45) NULL,
  `password` VARCHAR(45) NULL,
  `userType` ENUM('admin', 'subadmin', 'subscriber') NULL,
  `created_at` DATETIME NULL,
  `updated_at` VARCHAR(45) NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`services`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`services` ;

CREATE TABLE IF NOT EXISTS `mydb`.`services` (
  `id` INT NOT NULL,
  `name` VARCHAR(45) NULL,
  `description` VARCHAR(45) NULL,
  `price` INT NULL,
  `user_id` INT NULL,
  `created_at` DATETIME NULL,
  `updated_at` DATETIME NULL,
  PRIMARY KEY (`id`),
  INDEX `user_id_idx` (`user_id` ASC) VISIBLE,
  CONSTRAINT `user_id`
    FOREIGN KEY (`user_id`)
    REFERENCES `mydb`.`users` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`clients`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`clients` ;

CREATE TABLE IF NOT EXISTS `mydb`.`clients` (
  `id` INT NOT NULL,
  `fullName` VARCHAR(45) NULL,
  `email` VARCHAR(45) NULL,
  `phone` VARCHAR(45) NULL,
  `address` VARCHAR(200) NULL,
  `taxId` VARCHAR(45) NULL,
  `source` VARCHAR(200) NULL,
  `notes` VARCHAR(45) NULL,
  `user_id` INT NULL,
  `created_at` DATETIME NULL,
  `updated_at` DATETIME NULL,
  PRIMARY KEY (`id`),
  INDEX `user_id_idx` (`user_id` ASC) VISIBLE,
  CONSTRAINT `user_id`
    FOREIGN KEY (`user_id`)
    REFERENCES `mydb`.`users` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`lead`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`lead` ;

CREATE TABLE IF NOT EXISTS `mydb`.`lead` (
  `id` INT NOT NULL,
  `client_id` VARCHAR(45) NULL,
  `requirement` TEXT(20000) NULL,
  `estimatedBudget` VARCHAR(45) NULL,
  `user_id` INT NULL,
  `startDate` DATETIME NULL,
  `deadline` DATETIME NULL,
  `created_at` DATETIME NULL,
  `updated_at` DATETIME NULL,
  `status` ENUM('In Progress', 'Order Generated', 'On Hold', 'Cancelled', 'Not Eligible') NULL,
  PRIMARY KEY (`id`),
  INDEX `user_id_idx` (`user_id` ASC) VISIBLE,
  CONSTRAINT `user_id`
    FOREIGN KEY (`user_id`)
    REFERENCES `mydb`.`users` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `client_id`
    FOREIGN KEY ()
    REFERENCES `mydb`.`clients` ()
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`leadDetails`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`leadDetails` ;

CREATE TABLE IF NOT EXISTS `mydb`.`leadDetails` (
  `id` INT NOT NULL,
  `lead_id` INT NULL,
  `services_id` INT NULL,
  `quantity` INT NULL,
  `notes` TEXT(2000) NULL,
  `created_at` DATETIME NULL,
  `updated_at` DATETIME NULL,
  PRIMARY KEY (`id`),
  INDEX `lead_id_idx` (`lead_id` ASC) VISIBLE,
  CONSTRAINT `services_id`
    FOREIGN KEY ()
    REFERENCES `mydb`.`services` ()
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `lead_id`
    FOREIGN KEY (`lead_id`)
    REFERENCES `mydb`.`lead` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`statusUpdates`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`statusUpdates` ;

CREATE TABLE IF NOT EXISTS `mydb`.`statusUpdates` (
  `id` INT NOT NULL,
  `lead_id` INT NULL,
  `notes` TEXT(2000) NULL,
  `status` VARCHAR(45) NULL,
  `user_id` INT NULL,
  `created_at` DATETIME NULL,
  `updated_at` DATETIME NULL,
  PRIMARY KEY (`id`),
  CONSTRAINT `lead_id`
    FOREIGN KEY ()
    REFERENCES `mydb`.`lead` ()
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `user_id`
    FOREIGN KEY ()
    REFERENCES `mydb`.`users` ()
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`todo`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`todo` ;

CREATE TABLE IF NOT EXISTS `mydb`.`todo` (
  `id` INT NOT NULL,
  `title` TEXT(500) NULL,
  `description` TEXT(2000) NULL,
  `dueDate` VARCHAR(45) NULL,
  `status` ENUM("Pending", "Complete") NULL,
  `user_id` INT NULL,
  `created_at` DATETIME NULL,
  `updated_at` DATETIME NULL,
  `lead_id` INT NULL,
  PRIMARY KEY (`id`),
  CONSTRAINT `user_id`
    FOREIGN KEY ()
    REFERENCES `mydb`.`users` ()
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
